package io.dekorate.openshift.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import io.dekorate.kubernetes.config.AzureDiskVolume;
import io.dekorate.kubernetes.config.PersistentVolumeClaimVolume;
import java.lang.StringBuilder;
import io.dekorate.kubernetes.config.Port;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import io.dekorate.kubernetes.config.Label;
import io.dekorate.kubernetes.config.Mount;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.kubernetes.config.Env;
import io.dekorate.kubernetes.config.Probe;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import io.dekorate.kubernetes.config.Container;
import java.lang.Deprecated;
import io.dekorate.kubernetes.annotation.ServiceType;
import java.util.Iterator;
import java.lang.Boolean;
import io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume;
import io.dekorate.kubernetes.config.ConfigMapVolume;
import io.dekorate.kubernetes.config.ConfigKey;
import io.dekorate.kubernetes.config.SecretVolume;
import io.dekorate.kubernetes.config.EnvFluent;
import io.dekorate.kubernetes.config.BaseConfigFluent;
import io.dekorate.kubernetes.config.Annotation;
import io.dekorate.kubernetes.config.AzureFileVolume;
import io.dekorate.project.Project;
import java.lang.StringBuffer;
import io.dekorate.kubernetes.annotation.ImagePullPolicy;
import io.dekorate.kubernetes.config.EnvBuilder;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;
import io.dekorate.kubernetes.config.GitRepoVolume;

public interface OpenshiftConfigFluent<A extends OpenshiftConfigFluent<A>> extends BaseConfigFluent<A>{


    public boolean isBuildResourceGenerationEnabled();
    public A withBuildResourceGenerationEnabled(boolean buildResourceGenerationEnabled);
    public Boolean hasBuildResourceGenerationEnabled();
    public String getBuilderImage();
    public A withBuilderImage(String builderImage);
    public Boolean hasBuilderImage();
    public A withNewBuilderImage(String arg1);
    public A withNewBuilderImage(StringBuilder arg1);
    public A withNewBuilderImage(StringBuffer arg1);
    public A withBuildEnvVars(io.dekorate.kubernetes.config.Env... buildEnvVars);
    
/**
 * This method has been deprecated, please use method buildBuildEnvVars instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Env[] getBuildEnvVars();
    public io.dekorate.kubernetes.config.Env[] buildBuildEnvVars();
    public io.dekorate.kubernetes.config.Env buildBuildEnvVar(int index);
    public io.dekorate.kubernetes.config.Env buildFirstBuildEnvVar();
    public io.dekorate.kubernetes.config.Env buildLastBuildEnvVar();
    public io.dekorate.kubernetes.config.Env buildMatchingBuildEnvVar(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public Boolean hasMatchingBuildEnvVar(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public A addToBuildEnvVars(int index,io.dekorate.kubernetes.config.Env item);
    public A setToBuildEnvVars(int index,io.dekorate.kubernetes.config.Env item);
    public A addToBuildEnvVars(io.dekorate.kubernetes.config.Env... items);
    public A addAllToConfigBuildEnvVars(Collection<io.dekorate.kubernetes.config.Env> items);
    public A removeFromBuildEnvVars(io.dekorate.kubernetes.config.Env... items);
    public A removeAllFromConfigBuildEnvVars(Collection<io.dekorate.kubernetes.config.Env> items);
    public A removeMatchingFromConfigBuildEnvVars(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public Boolean hasBuildEnvVars();
    public A addNewConfigBuildEnvVar(String name,String value,String secret,String configmap,String field);
    public OpenshiftConfigFluent.ConfigBuildEnvVarsNested<A> addNewConfigBuildEnvVar();
    public OpenshiftConfigFluent.ConfigBuildEnvVarsNested<A> addNewBuildEnvVarLike(io.dekorate.kubernetes.config.Env item);
    public OpenshiftConfigFluent.ConfigBuildEnvVarsNested<A> setNewBuildEnvVarLike(int index,io.dekorate.kubernetes.config.Env item);
    public OpenshiftConfigFluent.ConfigBuildEnvVarsNested<A> editBuildEnvVar(int index);
    public OpenshiftConfigFluent.ConfigBuildEnvVarsNested<A> editFirstBuildEnvVar();
    public OpenshiftConfigFluent.ConfigBuildEnvVarsNested<A> editLastBuildEnvVar();
    public OpenshiftConfigFluent.ConfigBuildEnvVarsNested<A> editMatchingBuildEnvVar(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public boolean isAutoBuildEnabled();
    public A withAutoBuildEnabled(boolean autoBuildEnabled);
    public Boolean hasAutoBuildEnabled();

    public interface ConfigBuildEnvVarsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,EnvFluent<OpenshiftConfigFluent.ConfigBuildEnvVarsNested<N>>{

        
    public N and();    public N endConfigBuildEnvVar();
}


}
